import QtQuick 2.9
import QtQuick.Window 2.2
import QtQuick.Layouts 1.2
import QtQuick.Controls 1.4

Window {
    id: root;
    visible: true
    width: 640
    height: 480
    title: accountname;

    property string accountname: "Běžný účet FIO";
    property string token: "WFJ2UHObAdhRTB9StoachMmzSnF0yFtnCAIrBaajZizvoTHsOXLzReWJcYuidngu";
    property int days: 30;

    Rectangle {
        anchors.fill: parent;
        anchors.leftMargin: 9;
        anchors.rightMargin: 9;
        anchors.bottomMargin: 5;

        Text  {
            id: label1;
            text: root.accountname;
            font.pixelSize: 24;
            height: font.pixelSize*1.9;
            horizontalAlignment: Text.AlignLeft;
            verticalAlignment: Text.AlignVCenter;
            anchors.top: parent.top;
            anchors.left: parent.left;
            }

        Text  {
            id: zustatek;
            text: "unknown";
            font.pixelSize: label1.font.pixelSize;
            height: label1.height;
            horizontalAlignment: Text.AlignRight;
            verticalAlignment: Text.AlignVCenter;
            anchors.top: parent.top;
            anchors.right: parent.right;
            anchors.left: label1.right;
            }

        ListView {
            id: listview;
            anchors.top: label1.bottom;
            anchors.left: parent.left;
            anchors.right: parent.right;
            anchors.bottom: parent.bottom;
            spacing: 5;
            clip: true;
            delegate: Rectangle {
                width: parent.width;
                height: childrenRect.height * 1.3;
                color: "lightgray";
                radius: 5;

                Text {
                    id: text1;
                    text: modelData.datum +
                         ( (modelData.protiucet !== '')
                                ? (" – " + modelData.protiucet + " " + modelData.nazev)
                                : ""
                          );
                    anchors.left: parent.left;
                    font.pixelSize: 18;
                    height: font.pixelSize * 1.3;
                    }

                Text {
                    id: text2;
                    text: modelData.zprava;
                    font.pixelSize: 16;
                    anchors.top: text1.bottom;
                    anchors.left: parent.left;
                    height: font.pixelSize * 1.3;
                    }

                Text {
                    id: textmena;
                    anchors.right: parent.right;
                    text: modelData.objem + " " + modelData.mena;
                    font.pixelSize:  18;
                    height: font.pixelSize * 1.6;
                    color: (modelData.objem > 0) ? "black" : "red";
                    }

                }
            }
        }


    Timer {
        id: timer;
        interval: 50;
        running: true;
        repeat: true;
        onTriggered: {
            getFioData();
            timer.interval = 300000
            }
        }

    function getFioData() {
        Number.prototype.pad = function(size) {
            var s = String(this);
            while (s.length < (size || 2)) { s = "0" + s; }
            return s;
            };
        Date.prototype.addDays = function(days) {
            var result = new Date(this);
            result.setDate(result.getDate() + days);
            return result;
            };
        Date.prototype.toMyString = function() {
            var y = this.getFullYear();
            var m = this.getMonth() + 1;
            var d = this.getDate();
            var s = y.pad(4) + '-' + m.pad(2) + '-' + d.pad(2);
            return s;
            };
        var date = new Date();
        var datefrom = date.addDays(-root.days).toMyString();
        var dateto = date.toMyString();
        var url = "https://www.fio.cz/ib_api/rest/periods/"
                + root.token + "/"
                + datefrom + "/" + dateto + "/transactions.json";
        var rq = new XMLHttpRequest();
        rq.open("GET", url, true);
        rq.send();
        rq.onreadystatechange = function() {
            if (rq.readyState === XMLHttpRequest.DONE && rq.status === 200) {
                var model = [];
                var data = JSON.parse(rq.responseText);
                zustatek.text = data.accountStatement.info.closingBalance + ' '
                              + data.accountStatement.info.currency;
                for (var i=data.accountStatement.transactionList.transaction.length-1; i>=0 ; i--) {
                    var linedata = data.accountStatement.transactionList.transaction[i];
                    var line = new Object;
                    if (linedata === null) { continue; }
                    line.datum     = linedata.column0.value.substring(8,10) + '.'
                                   + linedata.column0.value.substring(5,7) + '.'
                                   + linedata.column0.value.substring(0,4);
                    line.objem     = linedata.column1.value;
                    line.protiucet = (linedata.column2 === null || linedata.column3 === null)
                                    ? ""
                                    : (linedata.column2.value + "/" + linedata.column3.value);
                    line.nazev     = (linedata.column10 === null) ? "" : linedata.column10.value;
                    line.zprava    = (linedata.column16 === null) ? "" : linedata.column16.value;
                    line.komentar  = (linedata.column25 === null) ? "" : linedata.column25.value;
                    line.mena      = (linedata.column14 === null) ? "" : linedata.column14.value;
                    model.push(line);
                    }
                listview.model = model;
                }
            }
        rq.onerror = function() {
            console.log("*** Chyba při tahání dat z FIO ***");
            }
        }

}
